/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Breadth first search routing algorithm
// George F. Riley, Georgia Tech, Winter 2000

#ifndef __BFS_H__
#define __BFS_H__

#include "common-defs.h"
#include "node.h"

// The prototype for the shortest path function
// Returns the node identifier of the node with the specified targetIP.
NodeId_t BFS(const NodeVec_t& N,       // List of nodes in the graph
         Node*                root,    // Root node for route computations
         NodeIfVec_t&         NextHop, // Returned "NextHop" vector
         NodeVec_t&           Parent,  // Returned "Parent" vector
         IPAddr_t             targetIP,// IP Address of target
         IPAddrVec_t&         aliases);// List of IP's with same path
#endif

extern int bfs_calls;
extern int bfs_nodessearched;
