/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Georgia Tech Network Simulator - Global Statistics 
// George F. Riley.  Georgia Tech, Spring 2002

#include <iostream>

#include "debug.h"
#include "globalstats.h"
#include "node.h"

using namespace std;

// Static members
Size_t             Stats::initialMemory;
Size_t             Stats::modelMemory;
Size_t             Stats::routingMemory;
Size_t             Stats::finalMemory;
unsigned long long Stats::linksCreated;
unsigned long long Stats::pktsEnqued;
unsigned long long Stats::pktsDequed;
unsigned long long Stats::pktsDropped;
unsigned long long Stats::pktsTransmitted;
unsigned long long Stats::pktsAllocated;
unsigned long long Stats::pktsDeleted;
unsigned long long Stats::pdusAllocated;
unsigned long long Stats::pdusDeleted;
unsigned long long Stats::dataPdusAllocated;
unsigned long long Stats::dataPdusDeleted;
unsigned long long Stats::eventsAllocated;
unsigned long long Stats::eventsDeleted;
unsigned long long Stats::timersAllocated;
unsigned long long Stats::timersDeleted;
unsigned long long Stats::nvCreated;
unsigned long long Stats::nvAllocated;
unsigned long long Stats::nvDeleted;
unsigned long long Stats::nvReused;
unsigned long long Stats::routingEntAllocated;
unsigned long long Stats::routingEntDeleted;
unsigned long long Stats::tcpAllocated;
unsigned long long Stats::tcpDeleted;
unsigned long long Stats::tcpTimers;
unsigned long long Stats::tcpTimeouts;
unsigned long long Stats::tcpDupAckRetx;
unsigned long long Stats::tcpRetxTimeouts;
unsigned long long Stats::sequentialEvList;
unsigned long long Stats::ospfTxPktsDropped;
unsigned long long Stats::ospfTxCollisions;
unsigned long long Stats::ospfRxErrors;

void Stats::Print()
{
  //DBG((
  cout << "Global Statistics" << endl\
       << "  Initial Memory       " << initialMemory << endl\
       << "  After Model Memory   " << modelMemory << endl\
       << "  After Routing Memory " << routingMemory << endl\
       << "  Final Memory         " << finalMemory << endl\
       << "  Links Created        " << linksCreated << endl\
       << "  Nodes Created        " << Node::nextId << endl\
       << "  Packets Enqued       " << pktsEnqued << endl\
       << "  Packets Dequed       " << pktsDequed << endl\
       << "  Packets Dropped      " << pktsDropped << endl\
       << "  Packets Transmitted  " << pktsTransmitted << endl\
       << "  Packets Allocated    " << pktsAllocated << endl\
       << "  Packets Deleted      " << pktsDeleted << endl\
       << "  PDUs Allocated       " << pdusAllocated << endl\
       << "  PDUs Deleted         " << pdusDeleted << endl\
       << "  Data PDUs Allocated  " << dataPdusAllocated << endl\
       << "  Data PDUs Deleted    " << dataPdusDeleted << endl\
       << "  Events Allocated     " << eventsAllocated << endl\
       << "  Events Deleted       " << eventsDeleted << endl\
       << "  Timers Allocated     " << timersAllocated << endl\
       << "  Timers Deleted       " << timersDeleted << endl\
       << "  NixVec Created       " << nvCreated << endl\
       << "  NixVec Allocated     " << nvAllocated << endl\
       << "  NixVec Deleted       " << nvDeleted << endl\
       << "  NixVec Reused        " << nvReused << endl\
       << "  RtgEntries Allocated " << routingEntAllocated << endl\
       << "  RtgEntries Deleted   " << routingEntDeleted << endl\
       << "  TCP Allocated        " << tcpAllocated << endl\
       << "  TCP Deleted          " << tcpDeleted << endl\
       << "  TCP Timers           " << tcpTimers << endl\
       << "  TCP Timeouts         " << tcpTimeouts << endl\
       << "  TCP DupAck Retx      " << tcpDupAckRetx << endl\
       << "  TCP Retransmits      " << tcpRetxTimeouts << endl\
       << "  Sequential Events    " << sequentialEvList << endl\
       << "  OSPF TX pkts Dropped " << ospfTxPktsDropped << endl\
       << "  OSPF TX Collisions   " << ospfTxCollisions << endl\
       << "  OSPF RX Errors       " << ospfRxErrors<< endl\
    //       ));
    ;
}
