/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Georgia Tech Network Simulator - Global Statistics 
// George F. Riley.  Georgia Tech, Spring 2002

#ifndef __global_stats_h__
#define __global_stats_h__

#include "common-defs.h"

//Doc:ClassXRef
class Stats {
public:
  static void Print();
public:
  static Size_t             initialMemory;
  static Size_t             modelMemory;
  static Size_t             routingMemory;
  static Size_t             finalMemory;
  static unsigned long long linksCreated;
  static unsigned long long pktsEnqued;
  static unsigned long long pktsDequed;
  static unsigned long long pktsDropped;
  static unsigned long long pktsTransmitted;
  static unsigned long long pktsAllocated;
  static unsigned long long pktsDeleted;
  static unsigned long long pdusAllocated;
  static unsigned long long pdusDeleted;
  static unsigned long long dataPdusAllocated;
  static unsigned long long dataPdusDeleted;
  static unsigned long long eventsAllocated;
  static unsigned long long eventsDeleted;
  static unsigned long long timersAllocated;
  static unsigned long long timersDeleted;
  static unsigned long long nvCreated;
  static unsigned long long nvAllocated;
  static unsigned long long nvDeleted;
  static unsigned long long nvReused;
  static unsigned long long routingEntAllocated;
  static unsigned long long routingEntDeleted;
  static unsigned long long tcpAllocated;
  static unsigned long long tcpDeleted;
  static unsigned long long tcpTimers;
  static unsigned long long tcpTimeouts;
  static unsigned long long tcpDupAckRetx;
  static unsigned long long tcpRetxTimeouts;
  static unsigned long long sequentialEvList;
  static unsigned long long ospfTxPktsDropped;
  static unsigned long long ospfTxCollisions;
  static unsigned long long ospfRxErrors;
};

#endif
