/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Georgia Tech Network Simulator - Hexidecimal Conversions
// George F. Riley.  Georgia Tech, Spring 2002

#include <stdio.h>

#include "hex.h"

using namespace std;

string Hex2(const Byte_t b)
{ // 2 digit hex
  char tmp[16];
  sprintf(tmp, "0x%02x", b);
  return string(tmp);
}

string Hex4(const Word_t w)
{ // 4 digit hex
  char tmp[16];
  sprintf(tmp, "0x%04x", w);
  return string(tmp);
}

string Hex8(const Long_t l)
{ // 8 digit hex
  char tmp[16];
  sprintf(tmp, "0x%08lx", l);
  return string(tmp);
}

string Hex2n(const Byte_t b)
{ // 2 digit hex
  char tmp[16];
  sprintf(tmp, "%02x", b);
  return string(tmp);
}

string Hex4n(const Word_t w)
{ // 4 digit hex
  char tmp[16];
  sprintf(tmp, "%04x", w);
  return string(tmp);
}

string Hex8n(const Long_t l)
{ // 8 digit hex
  char tmp[16];
  sprintf(tmp, "%08lx", l);
  return string(tmp);
}

