/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Georgia Tech Network Simulator - Layer 4 Port Demultiplexer base class
// George F. Riley.  Georgia Tech, Spring 2002

// Define the layer 4 demux interface

#ifndef __l4demux_h__
#define __l4demux_h__

#include "protocol.h"
#include "l3protocol.h"

//Doc:ClassXRef
class L4Demux : public Protocol {
public:
  L4Demux() { }
  virtual ~L4Demux() { }
  virtual Layer_t Layer() { return 4;}   // Protocol layer number
public:
  // From lower layer     
#ifdef SIM
  virtual void DataIndication(Node*,Packet*,IPAddr_t,L3Protocol&,Interface*, IPAddr_t) =0;
#else
  virtual void DataIndication(Node*,Packet*,IPAddr_t,L3Protocol&,Interface*) =0;
#endif //SIM
};

#endif
