#ifndef __MYSTAT_H
#define __MYSTAT_H

#include <vector>
#include <map>

typedef unsigned long ulong;

class Times
{
public:
  Times() : t1(0), t2(0) {}
  Times(double t) : t1(t), t2(0) {}

public:
  double  t1;    // when pkt generated
  double  t2;    // when pkt received
};

class MyStat
{
public:
  typedef std::vector<ulong> UIDVec_t;
  typedef std::map<ulong, Times>  UIDMap_t;

  static UIDVec_t  uidList;
  static ulong  pktsRequested; // # of data pkts requested
  static ulong  pktsSent;      // # of data pkts sent
  static ulong  pktsReceived;  // # of data pkts received
  static ulong  count[6];

  static UIDMap_t  uidMap;
  static ulong  ctrlPkts[2];
  static ulong  ctrlBytes[2];
  static ulong  dataPkts[2];
  static ulong  dataBytes[2];
  static ulong  ctrlPktsUC;
  static ulong  ctrlPktsBC;


public:
  static void pktsReceive(ulong uid);
  static void pktsTimeStamp(ulong uid);
  static void Print();
};

#endif
