/*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
                                                                                
* Permission is hereby granted for any non-commercial use of this code
                                                                                
*/
                                                                                
// Boeing MANET OSPF6D port.  Copyright 2004, The Boeing Company

// Picks the OSPF6D instance by port number

#ifndef __ospfdemux_h__
#define __ospfdemux_h__

#include "l4demux.h"
#include "l3protocol.h"
#include "application-ospf6d.h"

//Doc:ClassXRef
class OSPF6Demux : public L4Demux {
public:
  OSPF6Demux();
  // from lower layer     
  virtual void DataIndication(Node*, Packet*, IPAddr_t,
                              L3Protocol&, Interface*, IPAddr_t = 0);
private:
  static OSPF6Demux* instance;  // Points to single instance of proto object
  static OSPF6DApplication* app_instance;
public:
  static OSPF6Demux* Instance();// Get a pointer to the single global instance
  static void  Initialize();  // Create the single global instance
	static void Register(OSPF6DApplication*); // Callback for OSPF6DApplication
};

#endif


