#ifdef SIM

#include "routing-ospf6.h"

using namespace std;

RoutingOSPF6::RoutingOSPF6() : Routing()
{

}

RoutingOSPF6::~RoutingOSPF6()
{

}


Routing::RType_t RoutingOSPF6::Type()
{
	  return OSPF6;
}



void RoutingOSPF6::Default(RoutingEntry r)
{ // Save default route to use when no NixVec can be calculated
  defaultRoute = r;
}

RoutingEntry RoutingOSPF6::GetDefault()
{
  return defaultRoute;
}

void RoutingOSPF6::Add( IPAddr_t a, Count_t m,
                            Interface* i, IPAddr_t ip)
{ // Ignored for nixvector routing
}

RoutingEntry RoutingOSPF6::Lookup(Node*, IPAddr_t t)
{ // Lookup routing entry for specified target address
  // Return an empty one to force a NV creation
  return RoutingEntry();
}

RoutingEntry RoutingOSPF6::LookupFromPDU(PDU*)
{// Find from PDU (NixVector)..not coded yet
  return RoutingEntry();
}

Routing* RoutingOSPF6::Clone()
{
  return new RoutingOSPF6();
}

void    RoutingOSPF6::InitializeRoutes(Node*)
{ // Initialization (none needed for nixvector routing
}

bool    RoutingOSPF6::NeedInit()
{ // Initialization not needed for nixvector routing
  return false;
}

Size_t  RoutingOSPF6::Size() const
{ // For statistics, return the size (bytes) of the FIB
  return 0;
}


#endif // SIM
