/*

* GTNetS provides a portable C++ class library for network simulations
*
* Copyright (C) 2003 George F. Riley
*
* No guarantees or warranties or anything are provided or implied in any way
* whatsoever.  Use this program at your own risk.  Permission to use this
* program for any purpose is given, as long as the copyright is kept intact.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

* Permission is hereby granted for any non-commercial use of this code

*/

// Georgia Tech Network Simulator - UDP Port Demultiplexer
// George F. Riley.  Georgia Tech, Spring 2002

// Picks the UDP instance by port number

#ifndef __udpdemux_h__
#define __udpdemux_h__

#include "l4demux.h"
#include "l3protocol.h"

//Doc:ClassXRef
class UDPDemux : public L4Demux {
public:
  UDPDemux();
  // from lower layer     
#ifdef SIM
  virtual void DataIndication(Node*, Packet*, IPAddr_t,
                              L3Protocol&, Interface*, IPAddr_t=0);
#else
  virtual void DataIndication(Node*, Packet*, IPAddr_t,
                              L3Protocol&, Interface*);
#endif //SIM
private:
  static UDPDemux* instance;  // Points to single instance of proto object
public:
  static UDPDemux* Instance();// Get a pointer to the single global instance
  static void  Initialize();  // Create the single global instance
};

#endif


