eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

use POSIX;
use Env;  #Environment Variables

# Generic option-grabbing code
sub Getopt
{
  local($spec) = @_;      # name of variables to be initialized from %opt
  &Usage  if ($#ARGV < 0);
  while ($_ = $ARGV[0], /^-(\w+)/) {
    shift @ARGV;
    $key = $1;
    $opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : &Usage;
  }
}

sub Usage
{
        $0 =~ s/.*\/([^\/]+)$/$1/o;
        print <<EOF;
Usage:  $0 [-run_gtnets <y|n>] [-average_stats <y|n>]
           [-ptmp <y|n>] [-mpr_flood <y|n>] 
           [-max_seed <SEED>] [-min_seed <SEED>]
           [-num_nodes <NUM>] [-pktrate <RATE>]
           [-results_dir <DIR>]

This script runs the code gtnets/validation/ietf_draft_wospf_design.cc over a number of seeds and then averages the statistics.
The GTNETS_HOME environment variable must be set to base gtnets dir.  Example /home/foo/gtnets.

-run_gtnets: inidicates if gtnets should be run to create stats and traces - default:y
-average:  indicates if the stats should be averaged - default:y
-ptmp:  run ptmp interface as wireless interface - default:y
-mpr_flood:  run manet interface with mprs as wireless interface - default:y
-max_seed:  the max seed to run - default:10
-min_seed:  the min seed to run - default:1
-num_nodes: number of nodes in wireless scenario -default:20
-pkt_rate:  rate at which pkts are generated on a network level - default:2
-results_dir:  directory based from $GTNETS_HOME where results will be saved - default: ./ietf

EOF
exit 1;
}

sub Finish
{
  print "Control-C... exiting parse.pl\n";
  exit 1;
}

unless ($GTNETS_HOME) {
  die "Environment variable GTNETS_HOME not set\n";
}

##### DEFAULT VALUES ######
$run = "y";
$average = "y";
$ptmp = "y";
$mprflood ="y";

$max_seed = 10; $min_seed=1;
$nodes = 20;
$pktrate = 2;
$results_dir = $GTNETS_HOME . "/ietf/";
$dir = $GTNETS_HOME . "/validation/ietf_draft_wospf_design";
@radio_range = (385, 290, 220);

# Only put entries below here that require a value to be indexed
&Getopt("run_gtnets:average_stats:ptmp:mpr_flood:max_seed:min_seed:num_nodes:pktrate:results_dir:");

# Process options
while(($key, $value) = each(%opt)) {
  if ($key eq "run_gtnets") {
    $run = $value;
  } elsif ($key eq "average_stats") {
    $average = $value;
  } elsif ($key eq "ptmp") {
    $ptmp = $value;
  } elsif ($key eq "mpr_flood") {
    $mprflood = $value;
  } elsif ($key eq "max_seed") {
    $max_seed = $value;
  } elsif ($key eq "min_seed") {
    $min_seed = $value;
  } elsif ($key eq "num_nodes") {
    $nodes = $value;
  } elsif ($key eq "pktrate") {
    $pktrate = $value;
  } elsif ($key eq "results_dir") {
    $results_dir = $value;
  } else {
    &Usage;
  }
}


####################################################################
############### RUN THE SIM ######################################
##################################################################

###PTMP#######
if ($ptmp eq "y") {
	$interface = 1;
	$figure = "ptmp";

	for ($i = 0; $i < @radio_range; $i++) {
		unless (-e "$results_dir/$figure") {
			system("mkdir $results_dir/$figure");
		}
		for ($seed = $min_seed; $seed <= $max_seed; $seed++)
		{
			run($dir, $results_dir, $figure, $radio_range[$i], $nodes, $seed, $interface);
		}
		average($results_dir, $figure, $radio_range[$i], $nodes);
	}	
}

#####MANET MPR FLOOD###########
if ($mprflood eq "y") {
	$interface = 2;
	$figure = "mprflood";

	for ($i = 0; $i < @radio_range; $i++) {
		unless (-e "$results_dir/$figure") {
			system("mkdir $results_dir/$figure");
		}
		for ($seed = $min_seed; $seed <= $max_seed; $seed++)
		{	
				run($dir, $results_dir, $figure, $radio_range[$i], $nodes, $seed, $interface);
		}
		average($results_dir, $figure, $radio_range[$i], $nodes);
	}
}


################################################################
################### SUBROUTINES ##############################
#############################################################

sub run
{
	if ($run ne "y") {
		return;
	}
	
	$count = 0;
	my($dir) = $_[$count]; $count++;
	my($results_dir) = $_[$count]; $count++;
	my($figure) = $_[$count]; $count++;
	my($radio_range) = $_[$count]; $count++;
	my($nodes) = $_[$count]; $count++;
	my($seed) = $_[$count]; $count++;
	my($interface) = $_[$count]; $count++;
	
	system("$dir/ietf_draft_wospf_design-dbg seed=$seed num_nodes=$nodes radio_range=$radio_range  wireless_interface=$interface pktrate=$pktrate");
	$file = $figure . "seed" . $seed . "range" .$radio_range."nodes".$nodes;
	system("mv $dir/ietf_draft_wospf_design-dbg.tr $results_dir/$figure/$file.tr");
	system("mv $dir/ietf_draft_wospf_design-dbg.stat $results_dir/$figure/$file.stat");
}

sub average
{
	if ($average ne "y") {
		return;
	}

	$count = 0;
	my($results_dir) = $_[$count]; $count++;
	my($figure) = $_[$count]; $count++;
	my($radio_range) = $_[$count]; $count++;
	my($nodes) = $_[$count]; $count++;
	
	$afile = $results_dir."/".$figure."/".$figure."range".$radio_range."nodes".$nodes.".avg";
  open(AVG, "> ".$afile);

  $count = 0;
  $hello_pkt = 0; $hello = 0; $hello_kbps = 0;
  $lsa_pkt = 0; $lsa = 0; $lsa_kbps = 0;
  $lsr_pkt = 0; $lsr = 0; $lsr_kbps = 0;
  $dd_pkt = 0; $dd = 0; $dd_kbps = 0;
  $lsu_pkt = 0; $lsu = 0; $lsu_kbps = 0;
  $lsuf_pkt = 0; $lsuf = 0; $lsuf_kbps = 0;
  $lsuu_pkt = 0; $lsuu = 0; $lsuu_kbps = 0;
  $lsuboth_pkt = 0; $lsuboth = 0; $lsuboth_kbps = 0;
  $lsurxmt_pkt = 0; $lsurxmt = 0; $lsurxmt_kbps = 0;
  $lsudbls_pkt = 0; $lsudbls = 0; $lsudbls_kbps = 0;
	
  $mhello_pkt = 0; $mhello = 0; $mhello_kbps = 0;
  $ospf_pkt = 0; $ospf = 0; $ospf_kbps = 0;
	
  $del_ratio=0; $avg_hops=0; $avg_f_hops=0;

  $avg_neigh=0; $neigh_chg=0; $neigh_life=0; $adj_rate=0; $LSA_sync=0;
  $avg_neigh{$pwr}=0; $neigh_chg{$pwr}=0; $neigh_life{$pwr}=0;
  $adj_rate{$pwr}=0; $LSA_sync{$pwr}=0;

	$mprsel_node=0; $mprsel_life=0; $sup_lsa=0;
	$mpr_flooded_lsa=0; $nonmpr_flooded_lsa=0;
	
	for ($seed = $min_seed; $seed <= $max_seed; $seed++)
	{
		$file = $figure . "seed" . $seed . "range" .$radio_range."nodes".$nodes;
		$data = $results_dir . "/" . $figure . "/" . $file . ".stat";
		if (open(DAT, "< ".$data)==0) {
			next;
		}
		$count++;
		while(<DAT>) {
      @col = split;
      if ($col[0] eq "Hello") {
        $hello_pkt+=$col[2]; $hello+=$col[3]; $hello_kbps+=$col[4];
      } elsif ($col[0] eq "LSAck") {
        $lsa_pkt+=$col[2]; $lsa+=$col[3]; $lsa_kbps+=$col[4];
      } elsif ($col[0] eq "LSR") {
        $lsr_pkt+=$col[2]; $lsr+=$col[3]; $lsr_kbps+=$col[4];
      } elsif ($col[0] eq "DBDESC") {
        $dd_pkt+=$col[2]; $dd+=$col[3]; $dd_kbps+=$col[4];
      } elsif ($col[0] eq "LSU") {
        $lsu_pkt+=$col[2]; $lsu+=$col[3]; $lsu_kbps+=$col[4];
      } elsif ($col[0] eq "LSUfld") {
        $lsuf_pkt+=$col[2]; $lsuf+=$col[3]; $lsuf_kbps+=$col[4];
      } elsif ($col[0] eq "LSUuni") {
        $lsuu_pkt+=$col[2]; $lsuu+=$col[3]; $lsuu_kbps+=$col[4];
      } elsif ($col[0] eq "LSUboth|") {
        $lsuboth_pkt+=$col[1]; $lsuboth+=$col[2]; $lsuboth_kbps+=$col[3];
      } elsif ($col[0] eq "LSUrxmt|") {
        $lsurxmt_pkt+=$col[1]; $lsurxmt+=$col[2]; $lsurxmt_kbps+=$col[3];
      } elsif ($col[0] eq "LSUdbls|") {
        $lsudbls_pkt+=$col[1]; $lsudbls+=$col[2]; $lsudbls_kbps+=$col[3];
      } elsif ($col[0] eq "Total") {
        $ospf_pkt+=$col[2]; $ospf+=$col[3]; $ospf_kbps+=$col[4];
      } elsif ($col[0] eq "Delivery") {
        $del_ratio+=$col[2]; $avg_hops+=$col[5]; $avg_f_hops+=$col[9];
      } elsif ($col[0] eq "neighbors/node:") {
        $avg_neigh += $col[1];
      } elsif ($col[0] eq "neighbor_changes/node/sec:") {
        $neigh_chg += $col[1];
      } elsif ($col[0] eq "avg_sec/neighbor_life:") {
        $neigh_life += $col[1];
      } elsif ($col[0] eq "new_adjacencies/node/sec:") {
        $adj_rate += $col[1];
      } elsif ($col[0] eq "avg_LSAsOutSync:") {
        $LSA_sync += $col[1];
      } elsif ($col[0] eq "mprsel/node:") {
        $mprsel_node += $col[1];
      } elsif ($col[0] eq "avg_sec/mprsel_life:") {
        $mprsel_life += $col[1];
      } elsif ($col[0] eq "suppressed_LSAs:") {
        $sup_lsa += $col[1];
      } elsif ($col[0] eq "mpr_flooded_LSAs:") {
        $mpr_flooded_lsa += $col[1];
      } elsif ($col[0] eq "nonmpr_flooded_LSAs:") {
        $nonmpr_flooded_lsa += $col[1];
      }
		}
		close(DAT);
	}
  if ($count == 0) {
		return;
  }

  $hello_pkt /= $count; $hello /= $count; $hello_kbps /= $count;
  $lsa_pkt /= $count; $lsa /= $count; $lsa_kbps /= $count;
  $lsr_pkt /= $count; $lsr /= $count; $lsr_kbps /= $count;
  $dd_pkt /= $count; $dd /= $count; $dd_kbps /= $count;
  $lsu_pkt /= $count; $lsu /= $count; $lsu_kbps /= $count;
  $lsuf_pkt /= $count; $lsuf /= $count; $lsuf_kbps /= $count;
  $lsuu_pkt /= $count; $lsuu /= $count; $lsuu_kbps /= $count;
  $lsuboth_pkt /= $count; $lsuboth /= $count; $lsuboth_kbps /= $count;
  $lsurxmt_pkt /= $count; $lsurxmt /= $count; $lsurxmt_kbps /= $count;
  $lsudbls_pkt /= $count; $lsudbls /= $count; $lsudbls_kbps /= $count;

  $mhello_pkt /= $count; $mhello /= $count; $mhello_kbps /= $count;
  $whello_pkt /= $count; $whello /= $count; $whello_kbps /= $count;
  $lsf_pkt /= $count; $lsf /= $count; $lsf_kbps /= $count;

  $ospf_pkt /= $count; $ospf /= $count; $ospf_kbps /= $count;
  $del_ratio /= $count; $avg_hops /= $count; $avg_f_hops /= $count;

  $avg_neigh = $avg_neigh/$count; $neigh_chg = $neigh_chg/$count;
  $neigh_life = $neigh_life/$count; $adj_rate = $adj_rate/$count;
  $LSA_sync = $LSA_sync/$count;
	
	$mprsel_node /= $count; $mprsel_life /= $count; $sup_lsa /= $count;
	$mpr_flooded_lsa /= $count; $nonmpr_flooded_lsa /= $count;

  printf(AVG "\nMobility             |\n");
  printf(AVG "-----------------------------------------------------\n");
  printf(AVG "avg-neighbors        |%8.2f\n", $avg_neigh);
  printf(AVG "neighbor-change-rate |%8.2f\n", $neigh_chg);
  printf(AVG "neighbor-life        |%8.2f\n", $neigh_life);
  printf(AVG "adjacency-rate       |%8.2f\n", $adj_rate);
  printf(AVG "LSAsOutSync          |%8.2f\n", $LSA_sync);


  printf(AVG "\nOspfv3 Overhead\n");
  printf(AVG "        | Packets          Bytes         Kbps\n");
  printf(AVG "----------------------------------------------------\n");

  printf(AVG "Hello      |%8d %14d %12.2f\n",
        $hello_pkt, $hello, $hello_kbps);
  printf(AVG "LSAck      |%8d %14d %12.2f\n",
        $lsa_pkt, $lsa, $lsa_kbps);
  printf(AVG "LSR        |%8d %14d %12.2f\n",
        $lsr_pkt, $lsr, $lsr_kbps);
  printf(AVG "DBDESC     |%8d %14d %12.2f\n",
        $dd_pkt, $dd, $dd_kbps);
  printf(AVG "LSU        |%8d %14d %12.2f\n",
       $lsu_pkt, $lsu, $lsu_kbps);
  printf(AVG "  LSUfld   |  %8d %14d %12.2f\n",
        $lsuf_pkt, $lsuf, $lsuf_kbps);
  printf(AVG "  LSUuni   |  %8d %14d %12.2f\n",
        $lsuu_pkt, $lsuu, $lsuu_kbps);
  printf(AVG "    LSUboth|  %8d %14d %12.2f\n",
        $lsuboth_pkt, $lsuboth, $lsuboth_kbps);
  printf(AVG "    LSUrxmt|  %8d %14d %12.2f\n",
        $lsurxmt_pkt, $lsurxmt, $lsurxmt_kbps);
  printf(AVG "    LSUdbls|  %8d %14d %12.2f\n",
        $lsudbls_pkt, $lsudbls, $lsudbls_kbps);
  printf(AVG "Total      |%8d %14d %12.2f\n",
        $ospf_pkt, $ospf, $ospf_kbps);

	printf(AVG "\nFlooding Statistics\n");
	printf(AVG "--------------------------------------------------\n");
	printf(AVG "mprsel/node          | %8.2f\n", $mprsel_node);
	printf(AVG "avg_sec/mprsel_life  | %8.2f\n", $mprsel_life);
	printf(AVG "suppressed LSAs      | %8d\n", $sup_lsa);
	printf(AVG "mpr flooded LSAs     | %8d\n", $mpr_flooded_lsa);
	printf(AVG "nonmpr flooded LSAs  | %8d\n", $nonmpr_flooded_lsa);

  printf(AVG "\nUDP Traffic\n");
  printf(AVG "-----------------------------------------------------\n");
	#printf(AVG "Delivery Ratio: %1.2f; Avg Hops: %1.2f; Avg Failed Hops: %1.2f\n", $del_ratio, $avg_hops, $avg_f_hops);
  printf(AVG "Delivery Ratio: %1.2f\n", $del_ratio);

  close(AVG);
}


