eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;

# Option-grabbing code
sub Getopt
{
	local($spec) = @_;	# name of variables to be initialized from %opt
	&Usage	if ($#ARGV < 0);
	while ($_ = $ARGV[0], /^-(\w+)/) {
		shift @ARGV;
		$key = $1;
    if ($key eq "num") {
      # num is a standalone option with no value
      $use_nums = 1;
      next;
    }
		$opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : 1;
	}

}

sub Usage
{
	$0 =~ s/.*\/([^\/]+)$/$1/o;
	print <<EOF;
Usage:  $0 -offsets [offsets] [-num] file(s)

Will go through the file(s) specified (may be wildcarded) and
will pick out the (space-delimited) fields and write them to
an output file ("output.dat"), one line per file, with the fields 
delimited by whitespace.

To pick out offsets 2,3,4,9,14, do the following
-offsets 2,3,4,9,14

Offsets are numbered starting from 0.

Option:
- num:  This variant will pick out only numbers (delimited by non-
numeric characters).  Be careful, e.g., OSPFv3 will pick out the "3"
	
EOF
	exit 1;
}

$use_nums = 0;
$outputfile = "output.dat";
&Getopt("offsets:num:");
$offsets = $opt{'offsets'} ? $opt{'offsets'} : die "Error: specify offsets $!";
# Any remaining arguments are files to parse
@filelist = @ARGV;

open(OUT, "> ".$outputfile) or die "Error: $outputfile, $!";
foreach $file (@filelist) {
  open(IN, "< ".$file) or die "Error: $file, $!";
  $index = 0;
  @selected = split(/,/, $offsets);

	#printf(OUT "%s ", $file);
	
  <IN>; #Read top line of file, discard
  while (<IN>) {
    if ($use_nums) {
      @fields = /([\d\.]+)/g;
    } else {
	    @fields = split;	
    }
    while (scalar(@fields)) {
      $current = shift @fields;
      if ($index == $selected[0]) {
        print OUT $current, " ";
        shift @selected;
      }
      $index++;
    }
  }
  close(IN);
  print OUT "\n";
}
close(OUT);

# How to convert grace graphs (AGR file) to EPS from command line?
# xmgrace -hdevice EPS -hardcopy -printfile test.eps test.agr
