eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
if 0;
use POSIX;
use Env;  #Environment Variables
		
#
# Runs the simulation script for different configurations (foreach loop)
# 
# For each configuration, runs simulation for $number times, starting 
# from base seed $baseseed, so that multiple runs may be averaged
#
# Note:  If you make the outer loop the repetitive one for looping
#        across different seeds, then you can guarantee that you have
#        at least some runs with each configuration if you have to 
#        abort execution early

$dir_rwp =  $GTNETS_HOME."/ietf/random_waypoint_manet";
$output = "output";

@mac = ("802_11", "TDMA");
@num_nodes = (10,20,30);
$num_seeds=10;
$baseseed=72;
$test="random_waypoint_manet";
@w_int=("sicds"); #("ptmp","mpr_flood","sicds");
@velocity=(5, 20);
@pause_time=(40);
@grid_length=(500, 707);
$diff_hellos = "n";
$lsa_cache = "n";

$rxmt = 10;
$hello = 2;
$lsint = 5;
$lsarr = 1;
$pb = 0.45;
$ack = 0.9;
$pb_ = floor(($rxmt * $pb)*1000);
$ack_ = floor($pb_*$ack);


if(1) {
#create directories
foreach $num_nodes (@num_nodes) {
foreach $mac (@mac) {
foreach $w_int(@w_int) {
  $odir=$dir_rwp."/".$output."/".$mac."/".$w_int."/".$test."-".$num_nodes."/";
  if ($lsa_cache eq "y") {
    $odir .= "lsa_cache/";
  } elsif ($diff_hellos eq "y") {
    $odir .= "diff_hellos/";
  } 
	system("mkdir -p $odir");
}
}
} 

#run simulation per seed, node, and interface
for($index = 0; $index < $num_seeds; $index++) {
	$seed = $baseseed + $index;
	foreach $mac(@mac) {
	foreach $num_nodes(@num_nodes) {
	foreach $velocity(@velocity) {
	foreach $pause_time(@pause_time) {
	foreach $grid_length(@grid_length) {
	foreach $w_int(@w_int) {
		$tag="seed".$seed."vel".$velocity."pause".$pause_time."grid".$grid_length;
		if ($mac eq "TDMA") {
			$mac_proto = 1;
		} else {
			$mac_proto = 0;
		}
		if ($w_int eq "ptmp") {
    $int = 1;
    $flood = 0
  }
		elsif ($w_int eq "mpr_flood") {
			$int = 2;
			$flood = 1;
		}
		elsif ($w_int eq "sicds") {
			$int = 2;
			$flood = 2;
		} else {
    printf("error: bad wireless interface\n"); exit(0);
  }
		run();
	}#interface type
	} # grid_length
	} # pause_time
	} # velocity
	} #num_nodes
	} #mac
} #seed
} 

#compute statistics
foreach $mac(@mac) {
foreach $num_nodes (@num_nodes) {
foreach $velocity(@velocity) {
foreach $pause_time(@pause_time) {
foreach $grid_length(@grid_length) {
foreach $w_int(@w_int) {
  statistics();
}
}
}
}
}
}

#plotting sets
foreach $mac(@mac) {
foreach $velocity(@velocity) {
foreach $pause_time(@pause_time) {
foreach $grid_length(@grid_length) {
foreach $w_int(@w_int) {
  plot_set();
}
}
}
}
}

sub run {
  $cmd_input = " mac_protocol=".$mac_proto." wireless_interface=".$int.
               " wireless_flooding=".$flood.
               " seed=".$seed." tag=".$tag." pause_time=".$pause_time. 
               " velocity=".$velocity." grid_length=".$grid_length.
               " num_nodes=".$num_nodes." HelloInterval=".$hello.    
               " MinLSInterval=".$lsint." MinLSArrival=".$lsarr.
               " PushbackInterval=".$pb_." AckInterval=".$ack_.
               " RxmtInterval=".$rxmt;
  $odir=$dir_rwp."/".$output."/".$mac."/".$w_int."/".$test."-".$num_nodes."/";
  if ($lsa_cache eq "y") {
    $odir .= "lsa_cache/";
  } elsif ($diff_hellos eq "y") {
    $odir .= "diff_hellos/";
    $cmd_input .= " diff_hellos";
  }

  system("$dir_rwp/$test-opt $cmd_input > $dir_rwp/$test-opt-$tag.log");
  system("mv -f $dir_rwp/$test-opt-$tag.* $odir");
}

sub plot_set {
  $file="mean_vel".$velocity."pause".$pause_time."grid".$grid_length.".out";
  $odir=$dir_rwp."/".$output."/".$mac."/".$w_int; 

  $extra_dir = ".";
  if ($lsa_cache eq "y") {
    $extra_dir .= "lsa_cache";
  } elsif ($diff_hellos eq "y") {
    $extra_dir .= "diff_hellos";
  }

  system("cd $odir; $GTNETS_HOME/bin/pick_fields.pl -num -offsets 0,79,80 ./$test-*/$extra_dir/$file; mv output.dat $extra_dir/overhead_$file.dat");
  system("cd $odir; $GTNETS_HOME/bin/pick_fields.pl -num -offsets 0,113,114 ./$test-*/$extra_dir/$file; mv output.dat $extra_dir/deliveryratio_$file.dat");
}

sub statistics {
  $file="vel".$velocity."pause".$pause_time."grid".$grid_length;
  $odir=$dir_rwp."/".$output."/".$mac."/".$w_int."/".$test."-".$num_nodes."/";
  if ($lsa_cache eq "y") {
    $odir .= "lsa_cache/";
  } elsif ($diff_hellos eq "y") {
    $odir .= "diff_hellos/";
  }

  system("cd $odir; $GTNETS_HOME/bin/statistics.pl -both *$file.stat; mv mean.out mean_$file.out");
}
