eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
if 0;
use POSIX;
use Env;  #Environment Variables
		
#
# Runs the simulation script for different configurations (foreach loop)
# 
# For each configuration, runs simulation for $number times, starting 
# from base seed $baseseed, so that multiple runs may be averaged
#
# Note:  If you make the outer loop the repetitive one for looping
#        across different seeds, then you can guarantee that you have
#        at least some runs with each configuration if you have to 
#        abort execution early

$dir_rwp =  $GTNETS_HOME."/ietf/random_waypoint_manet";
$output = "output/sensitivity";

$test="random_waypoint_manet";
$mac = "802_11"; 
$w_int="mpr_flood";
$num_nodes = 20;
$pause_time=40;

$num_seeds=10;
$baseseed=72;
@velocity=(5, 20);
@grid_length=(500, 707);

@rxmt=(10, 5, 15);
@hello=(2, 1, 5, 10, 15);
@lsint=(5, 2, 10);
@lsarr=(1, 2, 3);
@pb=(0.45, 0.2, 0.3);
@ack=(0.9, 0.5, 0.75);

if ($w_int eq "mpr_flood") {
	$int = 2;
} else {
	$int = 1;
}
if ($mac eq "TDMA") {
	$mac_proto = 1;
} else {
	$mac_proto = 0;
}

if(1) {

$dir = $dir_rwp."/".$output."/".$mac."/".$w_int."/".$test."-".$num_nodes;
system("mkdir -p $dir");

#run simulation per seed, node, and interface
for($index = 0; $index < $num_seeds; $index++) {
	$seed = $baseseed + $index;
	foreach $velocity(@velocity) {
	foreach $grid_length(@grid_length) {
		$tag = "seed" . $seed . "vel" . $velocity . "grid" . $grid_length;
		
		set_defaults();
		foreach $hello(@hello) {
			$tag_ = $tag . "hello".$hello;
			run();
		}
		set_defaults();
		foreach $rxmt(@rxmt) {
			$tag_ = $tag . "rxmt".$rxmt;
			run();
		}
		set_defaults();
		foreach $lsint(@lsint) {
			$tag_ = $tag . "lsint".$lsint;
			run();
		}
		set_defaults();
		foreach $lsarr(@lsarr) {
			$tag_ = $tag . "lsarr".$lsarr;
			run();
		}
		set_defaults();
		foreach $pb(@pb) {
			$pb_ = floor(($rxmt * $pb)*1000);
			$ack_ = floor($pb_*$ack);
			$tag_ = $tag . "pb".$pb;
			run();
		}
		set_defaults();
		foreach $ack(@ack) {
			$ack_ = floor($pb_*$ack);
			$tag_ = $tag . "ack".$ack;
			run();
		}

	} # grid_length
	} # velocity
} #seed
}



###########STATISTICS#############

foreach $velocity(@velocity) {
foreach $grid_length(@grid_length) {
	$file= "vel".$velocity."grid".$grid_length;
	
	foreach $hello(@hello) {
		$file_ = $file . "hello".$hello;
		statistics();
	}
	$mean = "mean_".$file."hello";
	plot_set();
	
	foreach $rxmt(@rxmt) {
		$file_ = $file . "rxmt".$rxmt;
		statistics();
	}	
	$mean = "mean_".$file."rxmt";
	plot_set();
	
	foreach $lsint(@lsint) {
		$file_ = $file . "lsint".$lsint;
		statistics();
	}
	$mean = "mean_".$file."lsint";
	plot_set();
	
	foreach $lsarr(@lsarr) {
		$file_ = $file . "lsarr".$lsarr;
		statistics();
	}
	$mean = "mean_".$file."lsarr";
	plot_set();
	
	foreach $pb(@pb) {
		$file_ = $file . "pb".$pb;
		statistics();
	}
	$mean = "mean_".$file."pb";
	plot_set();

	foreach $ack(@ack) {
		$file_ = $file . "ack".$ack;
		statistics();
	}
	$mean = "mean_".$file."ack";
	plot_set();
}
}
	




######SUBROUTINES#######

sub set_defaults {
	$rxmt = $rxmt[0];
	$hello = $hello[0];
	$lsint = $lsint[0];
	$lsarr = $lsarr[0];
	$pb = $pb[0];
	$ack = $ack[0];
	$pb_ = floor(($rxmt * $pb)*1000);
	$ack_ = floor($pb_*$ack);
}

sub plot_set {
	return;
	system("cd $dir_rwp/$output/$mac/$w_int/$test-$num_nodes; ~/gtnets/gtnets/bin/pick_fields.pl -num -offsets 79,80 $mean*; mv output.dat overhead$mean.dat");
	system("cd $dir_rwp/$output/$mac/$w_int/$test-$num_nodes; ~/gtnets/gtnets/bin/pick_fields.pl -num -offsets 113,114 $mean*; mv output.dat deliveryratio$mean.dat");
}

sub run {
	system("$dir_rwp/$test-opt mac_protocol=$mac_proto wireless_interface=$int seed=$seed tag=$tag_ pause_time=$pause_time velocity=$velocity grid_length=$grid_length num_nodes=$num_nodes hello_int=$hello minls_int=$lsint minls_arrival=$lsarr pushback_int=$pb_ ack_int=$ack_ rxmt_int=$rxmt > $dir_rwp/$test-opt-$tag_.log");
	system("mv -f $dir_rwp/$test-opt-$tag_.* $dir_rwp/$output/$mac/$w_int/$test-$num_nodes");
}

sub statistics {
	system("cd $dir_rwp/$output/$mac/$w_int/$test-$num_nodes; $GTNETS_HOME/bin/statistics.pl -both *$file_.stat; mv mean.out mean_$file_.out");
}
